.Const
FILE_DEVICE_ECDRV     Equ    8050H       ; Minimo valor 8000H
IOCTL_ECDRV_BASE      Equ    FILE_DEVICE_ECDRV
IOCTL_ECDRV_INDEX     Equ    850H        ; Minimo valor 800H

IOCTL_EDCRV_READCMOS  Equ    CTL_CODE(IOCTL_ECDRV_BASE, IOCTL_ECDRV_INDEX, \
                                      METHOD_BUFFERED, FILE_ANY_ACCESS)
IOCTL_EDCRV_BEEP      Equ    CTL_CODE(IOCTL_ECDRV_BASE, IOCTL_ECDRV_INDEX + 1, \
                                      METHOD_BUFFERED, FILE_ANY_ACCESS)

ECDrvName             Equ    <"ECDriver">

;%Echo IOCTL_EDCRV_READCMOS

.Data?
TMP_Buffer            DB     MAX_PATH Dup (?)
TABs                  DD     20 Dup (?)

.Data
hList        HANDLE    0
hFile        HANDLE    0
ToHex                 DB     "0123456789ABCDEF"
NullStr               DB     0, 0

.Code

ECDrvTestProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    .If uMsg == WM_CREATE

    .ElseIf uMsg == ECM_AFTERCREATE
        Invoke GetWindowItem, hWnd, IDC_ECDRVTEST_LIST1
        Mov hList, Eax
        Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
        ;--
        Call Load_ECDrv
        Call Open_File
        ;--
    .ElseIf uMsg == WM_CLOSE
        ;--
        Call Close_file
        Call UnLoad_ECDrv
        ;--
        Invoke IsModal, hWnd
        .If Eax
            Invoke EndModal, hWnd, IDCANCEL
            Return TRUE
        .EndIf
    .ElseIf uMsg == WM_COMMAND
         LoWord wParam
         .If Ax == IDC_ECDRVTEST_BUTTON1
            HiWord wParam
            .If Ax == BN_CLICKED
               Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
               Call Make_Beep
               Return TRUE
            .EndIf
         .ElseIf Ax == IDC_ECDRVTEST_BUTTON2
            HiWord wParam
            .If Ax == BN_CLICKED
               Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
               Call Read_CMOS
               Return TRUE
            .EndIf
         .ElseIf Ax == IDC_ECDRVTEST_BUTTON3
            HiWord wParam
            .If Ax == BN_CLICKED
               Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
               Call Read_File
               Return TRUE
            .EndIf
         .EndIf
    .EndIf
    Return FALSE
ECDrvTestProcedure EndP

ECDrvTestList1 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    Return FALSE
ECDrvTestList1 EndP

ECDrvTestButton1 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    Return FALSE
ECDrvTestButton1 EndP

ECDrvTestButton2 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
    Return FALSE
ECDrvTestButton2 EndP

Load_ECDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local acDriverPath[MAX_PATH]:CHAR

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_CREATE_SERVICE
    .If Eax != NULL
        Mov hSCManager, Eax
        Invoke GetFullPathName, TextAddr(ECDrvName, ".sys"), SizeOf acDriverPath, Addr acDriverPath, NULL
        Invoke CreateService, hSCManager, TextAddr(ECDrvName), TextAddr("EC SYS Driver"), \
                       SERVICE_START + DELETE, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, \
                       SERVICE_ERROR_IGNORE, Addr acDriverPath, NULL, NULL, NULL, NULL, NULL
        .If Eax != NULL
            Mov hService, Eax
            Invoke StartService, hService, 0, NULL
            Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
    Ret
Load_ECDrv EndP

UnLoad_ECDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local sService:SERVICE_STATUS

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
    .If Eax != NULL
        Mov hSCManager, Eax
       Invoke OpenService, hSCManager, TextAddr(ECDrvName), SERVICE_ALL_ACCESS
       .If Eax != NULL
          Mov hService, Eax
            Invoke ControlService, hService, SERVICE_CONTROL_STOP, Addr sService
            Invoke DeleteService, hService
            Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
    ;--
    Ret
UnLoad_ECDrv EndP

Open_File Proc Private
     .If hFile != 0
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open File Err")
         Ret
     .EndIf
     Invoke CreateFile, TextAddr("\\.\", ECDrvName), GENERIC_READ Or GENERIC_WRITE, \
            FILE_SHARE_READ Or FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
     .If Eax != INVALID_HANDLE_VALUE
          Mov hFile, Eax
     .Else
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create File Err")
     .EndIf
    Ret
Open_File EndP

Close_file Proc Private
    .If hFile != 0
          Invoke CloseHandle, hFile
          Mov hFile, 0
    .EndIf
    Ret
Close_file EndP

Make_Beep Proc Private
          Local BRet:DWord
    .If hFile != 0
          Mov BRet, 0
          Invoke DeviceIoControl, hFile, IOCTL_EDCRV_BEEP, NULL, 0, NULL, 0, Addr BRet, NULL
          ;--BRet == valor devuelto en (_IRP ptr[eax]).IoStatus.Information,
          Invoke wsprintf, Addr TMP_Buffer, TextAddr("Control Ret: %u"), BRet
          Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
    .Else
          Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Control File Err")
    .EndIf
    Ret
Make_Beep EndP

Read_CMOS Proc Private Uses Ebx Ecx
          Local PID:DWord, BRet:DWord, Cnt:DWord
          Local InBuffer[MAX_PATH]:Byte
          Local OutBuffer[MAX_PATH]:Byte

       Invoke GetCurrentProcessId
       Mov PID, Eax
       Mov DWord Ptr InBuffer[0], Eax        ; Envio el PID en Buffer de entrada con Offset "0"
          ;--
          Mov BRet, 0
          Invoke RtlZeroMemory, Addr OutBuffer, SizeOf OutBuffer
          Invoke DeviceIoControl, hFile, IOCTL_EDCRV_READCMOS, Addr InBuffer, SizeOf InBuffer - 1, \
             Addr OutBuffer, SizeOf OutBuffer - 1, Addr BRet, NULL
          ;--
          Call SetTabs
          Call Hex_Dump
          Call CMOS_Info
          ;--
              Invoke wsprintf, Addr TMP_Buffer, TextAddr("Control Ret: %u"), BRet
              Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
          ;--
          Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
          Invoke wsprintf, Addr TMP_Buffer, TextAddr("PID sent:", 09, "%X"), PID
          Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
          Mov Ecx, DWord Ptr OutBuffer[150]  ; Recibe PID en Buffer de Salida en Offset "150"
          Invoke wsprintf, Addr TMP_Buffer, TextAddr("PID recv:", 09, "%X"), Ecx
          Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
    ;--
    Ret
    ;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

SetTabs:  ;*****************************************************************
          Mov TABs[0], 40
          Mov Eax, 40 + 13
          Mov Ecx, 1
          .While Ecx < 11H
             Mov TABs[Ecx * 4], Eax
             Add Eax, 13
             Inc Ecx
          .EndW
          Invoke SendMessage, hList, LB_SETTABSTOPS, 11H, Addr TABs
          Retn

Hex_Dump: ;*****************************************************************
          Text Addr40, "%04X", 09
          Invoke wsprintf, Addr TMP_Buffer, Addr Addr40, 0
          Mov Cnt, 0
          Mov Edi, 5
          .While Cnt < 80H
              Mov Ecx, Cnt
              Mov Al, OutBuffer[Ecx]
                  And Eax, 0FFH
                  Push Eax
                  Shr Eax, 4
                  Mov Al, ToHex[Eax]
                  Mov TMP_Buffer[Edi], Al
                  Inc Edi
                  Pop Eax
                  And Eax, 0FH
                  Mov Al, ToHex[Eax]
                  Mov TMP_Buffer[Edi], Al
                  Inc Edi
                  Mov Byte Ptr TMP_Buffer[Edi], 09H   ; Tab
                  Inc Edi
              Inc Cnt
              Test Cnt, 0FH
              .If Zero?
                  Mov Byte Ptr TMP_Buffer[Edi], 0     ; Cero final
                  Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
                  Invoke wsprintf, Addr TMP_Buffer, Addr Addr40, Cnt
                  Mov Edi, 5
              .Else
                  Test Cnt, 07H
                  .If Zero?
                     Mov DWord Ptr TMP_Buffer[Edi], 092020H  ; "  " + Tab
                     Add Edi, 3
                  .EndIf
              .EndIf
          .EndW
        Retn
CMOS_Info: ;****************************************************************
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
        Xor Ecx, Ecx
        Mov Cl, OutBuffer[4]
        Mov Edi, Ecx
        Mov Cl, OutBuffer[2]
        Mov Ebx, Ecx
        Mov Cl, OutBuffer[0]
        Invoke wsprintf, Addr TMP_Buffer, TextAddr("Hora:", 09, "%02X:%02X:%02X", 09, "h:m:s"), Edi, Ebx, Ecx
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
        Xor Ecx, Ecx
        Mov Cl, OutBuffer[7]
        Mov Edi, Ecx
        Mov Cl, OutBuffer[8]
        Mov Ebx, Ecx
        Mov Cl, OutBuffer[9]
        Invoke wsprintf, Addr TMP_Buffer, TextAddr("Fecha:", 09, "%02X/%02X/%02X", 09, "d:m:a"), Edi, Ebx, Ecx
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer

        Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
        Retn
        ;--
Read_CMOS EndP

Read_File Proc Private
                        Local InBuffer[MAX_PATH]:Byte
                        Local BRet:DWord
    Mov BRet, 0
    Invoke RtlZeroMemory, Addr InBuffer, SizeOf InBuffer
    Invoke ReadFile, hFile, Addr InBuffer, SizeOf InBuffer - 1, Addr BRet, NULL
    ;--
    ;Invoke WideCharToMultiByte, CP_ACP, 0, Addr InBuffer, -1, Addr TMP_Buffer, SizeOf TMP_Buffer - 1, 0, 0
    Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr InBuffer
    ;--
    Invoke wsprintf, Addr TMP_Buffer, TextAddr("Readed Ret: %u"), BRet
    Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer

    Ret
Read_File EndP
