;EasyCodeName=ECIrqDriver,1
.Const

ECDrvName        	Equ      <ECIrqDriver>
NT_DEVICE_NAME   	CatStr   <"\Device\>,ECDrvName,<">
DOS_DEVICE_NAME  	CatStr   <"\DosDevices\>,ECDrvName,<">

IRQNUMBER           Equ       7

.Data?
KAFFINITY         TypeDef   DWord
PKINTERRUPT       TypeDef   DWord

DEVICE_EXTENSION Struct
	InterruptObject         PKINTERRUPT ?
    Level                   ULONG ?
    Vector                  ULONG ?
    Affinity                KAFFINITY   ?
DEVICE_EXTENSION EndS

.Data
DE       DEVICE_EXTENSION   <0>
Irql     KIRQL               0
IrqVector    DD              0

nRet         DD              0
PKINT        DD              0
Counter      DD              0

.Code

DriverEntry Proc pDriverObject:PDRIVER_OBJECT, pusRegistryPath:PUNICODE_STRING
	Local usDeviceName:UNICODE_STRING, usSymbolicLinkName:UNICODE_STRING
	Local pDeviceObject:PDEVICE_OBJECT

	Invoke RtlInitUnicodeString, Addr usDeviceName, TextAddrW(%NT_DEVICE_NAME)
	Invoke RtlInitUnicodeString, Addr usSymbolicLinkName, TextAddrW(%DOS_DEVICE_NAME)

	Invoke IoCreateDevice, pDriverObject, SizeOf DEVICE_EXTENSION, Addr usDeviceName, \
							FILE_DEVICE_UNKNOWN, 0, TRUE, Addr pDeviceObject
	.If Eax != STATUS_SUCCESS
		Mov Eax, STATUS_DEVICE_CONFIGURATION_ERROR
		Ret
	.EndIf

	Invoke IoCreateSymbolicLink, Addr usSymbolicLinkName, Addr usDeviceName
	.If Eax != STATUS_SUCCESS
		Invoke IoDeleteDevice, pDriverObject
		Mov Eax, STATUS_DEVICE_CONFIGURATION_ERROR
		Ret
	.EndIf

	Mov Eax, pDriverObject
	Mov (DRIVER_OBJECT Ptr [Eax]).DriverUnload, Offset DriverUnload

	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_CREATE * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_CLOSE * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_DEVICE_CONTROL * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_READ * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_WRITE * (SizeOf PVOID)], Offset DriverDispatch

    ;--------
    Invoke RtlZeroMemory, Addr DE, SizeOf DE
    Mov DE.Level, IRQNUMBER
    Move DE.Vector, DE.Level
    Invoke HalGetInterruptVector, Isa, 0, DE.Level, DE.Vector, Addr Irql, Addr DE.Affinity
    Mov IrqVector, Eax
    .If Eax != 0
       ;Invoke HalDisableSystemInterrupt, IrqVector, 0
       Movzx Edx, Irql
       Invoke IoConnectInterrupt, Addr DE.InterruptObject, Offset InterruptService, \
  					    pDeviceObject, NULL, IrqVector, Edx, Edx, LevelSensitive, \
  					    TRUE, DE.Affinity, FALSE
  	   Mov nRet, Eax
  	   Move PKINT, DE.InterruptObject
  	   ;Invoke HalEnableSystemInterrupt, IrqVector, 0, 0
  	.EndIf
  	Mov Eax, pDeviceObject
    Invoke RtlMoveMemory, (DEVICE_OBJECT Ptr [Eax]).DeviceExtension, Addr DE, SizeOf DE
    ;--------
	Mov Eax, STATUS_SUCCESS
	Ret
DriverEntry EndP

DriverUnload Proc pDriverObject:PDRIVER_OBJECT
	Local usSymbolicLinkName:UNICODE_STRING
    ;--------
    .If IrqVector != 0
       ;Invoke HalDisableSystemInterrupt, IrqVector, 0
       .If nRet == STATUS_SUCCESS
	       Mov Eax, pDriverObject
	       Mov Eax, (DRIVER_OBJECT Ptr [Eax]).DeviceObject
           Mov Eax, (DEVICE_OBJECT Ptr [Eax]).DeviceExtension
           Mov Eax, (DEVICE_EXTENSION Ptr [Eax]).InterruptObject
	       Invoke IoDisconnectInterrupt, Eax
	       ;Invoke IoDisconnectInterrupt, PKINT
	   .EndIf
       ;Invoke HalEnableSystemInterrupt, IrqVector, 0, 0
    .EndIf
    ;--------
	Invoke RtlInitUnicodeString, Addr usSymbolicLinkName, TextAddrW(%DOS_DEVICE_NAME)
	Invoke IoDeleteSymbolicLink, Addr usSymbolicLinkName

	Mov Eax, pDriverObject
	Invoke IoDeleteDevice, (DRIVER_OBJECT Ptr [Eax]).DeviceObject
	Ret
DriverUnload EndP

DriverDispatch Proc Uses Ecx Edx pDeviceObject:PDEVICE_OBJECT, pIrp:PIRP
	Local Status:NTSTATUS, Info:DWord, IO_S_L:DWord

    Local RBufPtr:DWord           ; Buffer
    Local RBufLen:SDWord          ; Buffer Len

	Mov Info, 0H
	Mov Eax, pIrp
	Mov Eax, (_IRP Ptr [Eax]).Tail.Overlay.CurrentStackLocation
	Mov IO_S_L, Eax

	Movzx Eax, (IO_STACK_LOCATION Ptr [Eax]).MajorFunction

	.If Eax == IRP_MJ_CREATE
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_CLOSE
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_DEVICE_CONTROL
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_READ
           Mov Eax, pIrp
           Move RBufPtr, (_IRP Ptr [Eax]).UserBuffer                   ; Buff Ptr
           ;Move RBufPtr, (_IRP Ptr [Eax]).AssociatedIrp.SystemBuffer   ; Buff Ptr
           Mov Eax, IO_S_L
           Move RBufLen, (IO_STACK_LOCATION Ptr [Eax]).Parameters.Read.dwLength  ; READ Out Buff Len
           ;--
             Invoke RtlZeroMemory, RBufPtr, RBufLen
             Push Ebx
               Mov Ebx, RBufPtr
               Mov Eax, IrqVector
               Mov [Ebx], Eax
               Mov Al, Irql
               Mov [Ebx + 4], Al
               Mov Eax, nRet
               Mov [Ebx + 8], Eax
               Mov Eax, PKINT
               Mov [Ebx + 12], Eax
               Mov Eax, Counter
               Mov [Ebx + 16], Eax
                  Add Ebx, 20
                  Mov Edx, 1
                  .While Edx < 16
                    Push Ebx
                    Push Edx
                    Mov Irql, 0
    Invoke HalGetInterruptVector, Internal, 0, Edx, Edx, Addr Irql, Addr DE.Affinity
                    Pop Edx
                    Pop Ebx
                    Mov [Ebx], Eax
                    Mov Al, Irql
                    Mov [Ebx + 4], Al
                    Add Ebx, 5
                    Inc Edx
                  .EndW
    Invoke KeQueryActiveProcessors
    Mov [Ebx], Eax
             Pop Ebx
             Move Info, RBufLen
           ;--
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_WRITE
		Mov Status, STATUS_SUCCESS
	.Else
		Mov Status, STATUS_NOT_IMPLEMENTED
	.EndIf

	Mov Eax, pIrp
	Move (_IRP Ptr [Eax]).IoStatus.Status, Status
	Move (_IRP Ptr [Eax]).IoStatus.Information, Info

    ;IoCompleteRequest is suposed to be defined as fastcall,
    ;which means the first two parameters have to be passed
    ;in Ecx and Edx registers.
	Mov Edx, IO_NO_INCREMENT
	Mov Ecx, pIrp
	Call IoCompleteRequest
	Mov Eax, Status
	Ret
DriverDispatch EndP

InterruptService Proc Interrupt:PKINTERRUPT, ServiceContext:PVOID
    Inc Counter
	Return FALSE
	;Return TRUE
InterruptService EndP

End DriverEntry
