.Const
ECDrvName                Equ    <"ECIrqDriver">


.Data?
TMP_Buffer               DB     MAX_PATH Dup (?)
Renglon                  DB     MAX_PATH Dup (?)
TABs                     DD     20 Dup (?)

.Data
hList                 HANDLE    0
hFile                 HANDLE    0
NullStr                  DD     0
TAB                      DB     09, 00, 00

.Code

ECIrqDrvTestProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_CREATE

	.ElseIf uMsg == ECM_AFTERCREATE
	    Invoke GetWindowItem, hWnd, IDC_ECIRQDRVTEST_LIST1
	    Mov hList, Eax
	    Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
           Mov Eax, Offset TABs
           Mov DWord Ptr [Eax], 60
           Mov DWord Ptr [Eax + 4], 100
        Invoke SendMessage, hList, LB_SETTABSTOPS, 2, Addr TABs
	    ;--
	    Call Load_ECPDrv
	    Call Open_File
	    ;--
	.ElseIf uMsg == WM_CLOSE
        ;--
        Call Close_file
        Call UnLoad_ECPDrv
        ;--
		Invoke IsModal, hWnd
		.If Eax
			Invoke EndModal, hWnd, IDCANCEL
			Return TRUE
		.EndIf
	.ElseIf uMsg == WM_COMMAND
         LoWord wParam
         .If Ax == IDC_ECIRQDRVTEST_BUTTON1
            HiWord wParam
            .If Ax == BN_CLICKED
               Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
               Call Read_File
               Return TRUE
            .EndIf
         .EndIf
	.EndIf
	Return FALSE
ECIrqDrvTestProcedure EndP

ECIrqDrvTestList1 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECIrqDrvTestList1 EndP

ECIrqDrvTestButton1 Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECIrqDrvTestButton1 EndP

Load_ECPDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local acDriverPath[MAX_PATH]:CHAR

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_CREATE_SERVICE
    .If Eax != NULL
        Mov hSCManager, Eax
        Invoke GetFullPathName, TextAddr(ECDrvName, ".sys"), SizeOf acDriverPath, Addr acDriverPath, NULL
	    Invoke CreateService, hSCManager, TextAddr(ECDrvName), TextAddr("EC SYS Driver"), \
				       SERVICE_START + DELETE, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, \
				       SERVICE_ERROR_IGNORE, Addr acDriverPath, NULL, NULL, NULL, NULL, NULL
        .If Eax != NULL
			Mov hService, Eax
		    Invoke StartService, hService, 0, NULL
		    Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
	Ret
Load_ECPDrv EndP

UnLoad_ECPDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local sService:SERVICE_STATUS

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
    .If Eax != NULL
        Mov hSCManager, Eax
	   Invoke OpenService, hSCManager, TextAddr(ECDrvName), SERVICE_ALL_ACCESS
	   .If Eax != NULL
		  Mov hService, Eax
            Invoke ControlService, hService, SERVICE_CONTROL_STOP, Addr sService
            Invoke DeleteService, hService
		    Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
    ;--
	Ret
UnLoad_ECPDrv EndP

Open_File Proc Private
     .If hFile != 0
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open File Err")
     	 Ret
     .EndIf
     Invoke CreateFile, TextAddr("\\.\", ECDrvName), GENERIC_READ Or GENERIC_WRITE, \
            FILE_SHARE_READ Or FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
     .If Eax != INVALID_HANDLE_VALUE
     	  Mov hFile, Eax
     .Else
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create File Err")
     .EndIf
	Ret
Open_File EndP

Close_file Proc Private
	.If hFile != 0
		  Invoke CloseHandle, hFile
		  Mov hFile, 0
	.EndIf
	Ret
Close_file EndP

Read_File Proc Private Uses Ebx
                        Local InBufferPtr:DWord
                        Local InBufferLen:DWord
                        Local BRet:DWord
    Mov InBufferLen, 100H
    Mov InBufferPtr, 0
    Mov BRet, 0
    Invoke GlobalAlloc, GPTR, InBufferLen
    .If Eax != 0
      Mov InBufferPtr, Eax
      Invoke ReadFile, hFile, InBufferPtr, InBufferLen, Addr BRet, NULL
      ;--
      .If BRet > 0
           Mov Ebx, InBufferPtr
           Mov Eax, [Ebx]
           Invoke wsprintf, Addr TMP_Buffer, TextAddr("IrqVector %s%X"), Addr TAB, Eax
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
           Mov Ebx, InBufferPtr
           Xor Eax, Eax
           Mov Al, [Ebx + 4]
           Invoke wsprintf, Addr TMP_Buffer, TextAddr("Irql %s%X"), Addr TAB, Eax
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
           Mov Ebx, InBufferPtr
           Mov Eax, [Ebx + 8]
           Invoke wsprintf, Addr TMP_Buffer, TextAddr("nRet %s%X"), Addr TAB, Eax
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
           Mov Ebx, InBufferPtr
           Mov Eax, [Ebx + 12]
           Invoke wsprintf, Addr TMP_Buffer, TextAddr("PKINT %s%X"), Addr TAB, Eax
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
           Mov Ebx, InBufferPtr
           Mov Eax, [Ebx + 16]
           Invoke wsprintf, Addr TMP_Buffer, TextAddr("Counter %s%u"), Addr TAB, Eax
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
           ;---
           Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
              Mov Ebx, InBufferPtr
              Add Ebx, 20
              Mov Edx, 1
              .While Edx < 16
              	 Push Ebx
              	 Push Edx
                    Mov Eax, [Ebx]
                    Mov Bl, [Ebx + 4]
                    And Ebx, 0FFH
                    Invoke wsprintf, Addr TMP_Buffer, TextAddr("IRQ %u%s%X%s  IRQL %X"), Edx, Addr TAB, Eax, Addr TAB, Ebx
                    Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
              	 Pop Edx
              	 Inc Edx
              	 Pop Ebx
              	 Add Ebx, 5
              .EndW
            ;---
            Mov Eax, [Ebx]
            Invoke wsprintf, Addr TMP_Buffer, TextAddr("Procesadores %s%u"), Addr TAB, Eax
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
      .EndIf
      ;--
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr NullStr
      Invoke wsprintf, Addr TMP_Buffer, TextAddr("Readed Ret: %s%u bytes"), Addr TAB, BRet
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
      ;--
      Invoke GlobalFree, InBufferPtr
    .Else
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Alloc Mem Err.")
    .EndIf
	Ret
Read_File EndP
