.Const

ECDrvName        	Equ      <ECTimeDriver>
NT_DEVICE_NAME   	CatStr   <"\Device\>,ECDrvName,<">
DOS_DEVICE_NAME  	CatStr   <"\DosDevices\>,ECDrvName,<">

.Data?

DEVICE_EXTENSION Struct
;This structure is driver-defined.
;It must be filled depending on
;the driver to be programmed.
DEVICE_EXTENSION EndS

.Data

.Code

DriverEntry Proc pDriverObject:PDRIVER_OBJECT, pusRegistryPath:PUNICODE_STRING
	Local usDeviceName:UNICODE_STRING, usSymbolicLinkName:UNICODE_STRING
	Local pDeviceObject:PDEVICE_OBJECT

	Invoke RtlInitUnicodeString, Addr usDeviceName, TextAddrW(%NT_DEVICE_NAME)
	Invoke RtlInitUnicodeString, Addr usSymbolicLinkName, TextAddrW(%DOS_DEVICE_NAME)

	Invoke IoCreateDevice, pDriverObject, SizeOf DEVICE_EXTENSION, Addr usDeviceName, \
							FILE_DEVICE_UNKNOWN, 0, TRUE, Addr pDeviceObject
	.If Eax != STATUS_SUCCESS
		Mov Eax, STATUS_DEVICE_CONFIGURATION_ERROR
		Ret
	.EndIf

	Invoke IoCreateSymbolicLink, Addr usSymbolicLinkName, Addr usDeviceName
	.If Eax != STATUS_SUCCESS
		Invoke IoDeleteDevice, pDriverObject
		Mov Eax, STATUS_DEVICE_CONFIGURATION_ERROR
		Ret
	.EndIf

	Mov Eax, pDriverObject
	Mov (DRIVER_OBJECT Ptr [Eax]).DriverUnload, Offset DriverUnload

	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_CREATE * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_CLOSE * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_DEVICE_CONTROL * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_READ * (SizeOf PVOID)], Offset DriverDispatch
	Mov (DRIVER_OBJECT Ptr [Eax]).MajorFunction[IRP_MJ_WRITE * (SizeOf PVOID)], Offset DriverDispatch

	Mov Eax, STATUS_SUCCESS
	Ret
DriverEntry EndP

DriverUnload Proc pDriverObject:PDRIVER_OBJECT
	Local usSymbolicLinkName:UNICODE_STRING

	Invoke RtlInitUnicodeString, Addr usSymbolicLinkName, TextAddrW(%DOS_DEVICE_NAME)
	Invoke IoDeleteSymbolicLink, Addr usSymbolicLinkName

	Mov Eax, pDriverObject
	Invoke IoDeleteDevice, (DRIVER_OBJECT Ptr [Eax]).DeviceObject
	Ret
DriverUnload EndP

DriverDispatch Proc Uses Ecx Edx pDeviceObject:PDEVICE_OBJECT, pIrp:PIRP
	Local Status:NTSTATUS, Info:DWord, IO_S_L:DWord

    Local RBufPtr:DWord           ; RBuffer
    Local RBufLen:SDWord          ; RBuffer Len
    Local WBufPtr:DWord           ; WBuffer
    Local WBufLen:SDWord          ; WBuffer Len

	Mov Info, 0H
	Mov Eax, pIrp
	Mov Eax, (_IRP Ptr [Eax]).Tail.Overlay.CurrentStackLocation
	Mov IO_S_L, Eax

	Movzx Eax, (IO_STACK_LOCATION Ptr [Eax]).MajorFunction

	.If Eax == IRP_MJ_CREATE
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_CLOSE
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_DEVICE_CONTROL
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_READ
            Mov Eax, pIrp
            Move RBufPtr, (_IRP Ptr [Eax]).UserBuffer                             ; BuffPtr
            Mov Eax, IO_S_L
            Move RBufLen, (IO_STACK_LOCATION Ptr [Eax]).Parameters.Read.dwLength  ; READ Out Buff Len
            ;--
            .If RBufLen >= SizeOf TIME_FIELDS
               Invoke HalQueryRealTimeClock, RBufPtr
               Move Info, SizeOf TIME_FIELDS
            .Else
               Mov Info, -1
            .EndIf
            ;--
		Mov Status, STATUS_SUCCESS
	.ElseIf Eax == IRP_MJ_WRITE
            Mov Eax, pIrp
            Move WBufPtr, (_IRP Ptr [Eax]).UserBuffer                             ; BuffPtr
            Mov Eax, IO_S_L
            Move WBufLen, (IO_STACK_LOCATION Ptr [Eax]).Parameters.Write.dwLength ; WRITE Out Buff Len
            ;--
            .If WBufLen >= SizeOf TIME_FIELDS
               Invoke HalSetRealTimeClock, WBufPtr
               Move Info, SizeOf TIME_FIELDS
            .Else
               Mov Info, -1
            .EndIf
            ;--
		Mov Status, STATUS_SUCCESS
	.Else
		Mov Status, STATUS_NOT_IMPLEMENTED
	.EndIf

	Mov Eax, pIrp
	Move (_IRP Ptr [Eax]).IoStatus.Status, Status
	Move (_IRP Ptr [Eax]).IoStatus.Information, Info

    ;IoCompleteRequest is suposed to be defined as fastcall,
    ;which means the first two parameters have to be passed
    ;in Ecx and Edx registers.
	Mov Edx, IO_NO_INCREMENT
	Mov Ecx, pIrp
	Call IoCompleteRequest
	Mov Eax, Status
	Ret
DriverDispatch EndP

End DriverEntry
