.Const
ECDrvName                Equ    <"ECTimeDriver">


.Data?
TIME_FIELDS Struct
     Year         SWord  ? ; 0000h range [1601...]
     Month        SWord  ? ; 0002h range [1..12]
     Day          SWord  ? ; 0004h range [1..31]
     Hour         SWord  ? ; 0006h range [0..23]
     Minute       SWord  ? ; 0008h range [0..59]
     Second       SWord  ? ; 000Ah range [0..59]
     Milliseconds SWord  ? ; 000Ch range [0..999]
     Weekday      SWord  ? ; 000Eh range [0..6] == [Sunday..Saturday]
TIME_FIELDS EndS

TMP_Buffer               DB     MAX_PATH Dup (?)
TABs                     DD     20 Dup (?)

.Data
TAB                      DB     09, 00, 00

hFile                 HANDLE    0

hList                 HANDLE    0
Y_hwnd                HANDLE    0
MO_hwnd               HANDLE    0
D_hwnd                HANDLE    0
H_hwnd                HANDLE    0
MI_hwnd               HANDLE    0
S_hwnd                HANDLE    0

TF                    TIME_FIELDS <0>
S_T                   SYSTEMTIME  <0>

.Code

ECTimeDrvTestProcedure Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_CREATE

	.ElseIf uMsg == ECM_AFTERCREATE
        Call Simple_Init
        Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
	    ;--
	    Call Load_ECTDrv
	    Call Open_File
	    ;--
	.ElseIf uMsg == WM_CLOSE
        ;--
        Call Close_file
        Call UnLoad_ECTDrv
        ;--
		Invoke IsModal, hWnd
		.If Eax
			Invoke EndModal, hWnd, IDCANCEL
			Return TRUE
		.EndIf
	.ElseIf uMsg == WM_COMMAND
         LoWord wParam
         .If Ax == IDC_ECTIMEDRVTEST_BUTTON1
            HiWord wParam
            .If Ax == BN_CLICKED
               Call Read_File
               Return TRUE
            .EndIf
         .ElseIf Ax == IDC_ECTIMEDRVTEST_BUTTON2
            HiWord wParam
            .If Ax == BN_CLICKED
               Call Write_File
               Return TRUE
            .EndIf
         .EndIf
	.EndIf
	Return FALSE
ECTimeDrvTestProcedure EndP

ECTimeDrvTestButton1 Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestButton1 EndP

Load_ECTDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local acDriverPath[MAX_PATH]:CHAR

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_CREATE_SERVICE
    .If Eax != NULL
        Mov hSCManager, Eax
        Invoke GetFullPathName, TextAddr(ECDrvName, ".sys"), SizeOf acDriverPath, Addr acDriverPath, NULL
	    Invoke CreateService, hSCManager, TextAddr(ECDrvName), TextAddr("EC SYS Driver"), \
				       SERVICE_START + DELETE, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, \
				       SERVICE_ERROR_IGNORE, Addr acDriverPath, NULL, NULL, NULL, NULL, NULL
        .If Eax != NULL
			Mov hService, Eax
		    Invoke StartService, hService, 0, NULL
		    Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
	Ret
Load_ECTDrv EndP

UnLoad_ECTDrv Proc Private
       Local hSCManager:HANDLE, hService:HANDLE
       Local sService:SERVICE_STATUS

    Invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
    .If Eax != NULL
        Mov hSCManager, Eax
	   Invoke OpenService, hSCManager, TextAddr(ECDrvName), SERVICE_ALL_ACCESS
	   .If Eax != NULL
		  Mov hService, Eax
            Invoke ControlService, hService, SERVICE_CONTROL_STOP, Addr sService
            Invoke DeleteService, hService
		    Invoke CloseServiceHandle, hService
        .Else
            Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open Service Err")
        .EndIf
        Invoke CloseServiceHandle, hSCManager
    .Else
        Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open SCManager Err")
    .EndIf
    ;--
	Ret
UnLoad_ECTDrv EndP

Open_File Proc Private
     .If hFile != 0
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Open File Err")
     	 Ret
     .EndIf
     Invoke CreateFile, TextAddr("\\.\", ECDrvName), GENERIC_READ Or GENERIC_WRITE, \
            FILE_SHARE_READ Or FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
     .If Eax != INVALID_HANDLE_VALUE
     	  Mov hFile, Eax
     .Else
         Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Create File Err")
     .EndIf
	Ret
Open_File EndP

Close_file Proc Private
	.If hFile != 0
		  Invoke CloseHandle, hFile
		  Mov hFile, 0
	.EndIf
	Ret
Close_file EndP

Read_File Proc Private Uses Ebx Ecx Edx
                        Local BRet:SDWord
      Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
      ;---
      Invoke RtlZeroMemory, Addr TF, SizeOf TF
      Mov BRet, 0
      Invoke ReadFile, hFile, Addr TF, SizeOf TF, Addr BRet, NULL
      ;--
      .If BRet >= 0
          Call ShowTimeDate
      .EndIf
      ;--
      Invoke GetLocalTime, Addr S_T
      Movzx Ebx, S_T.wDay
      Movzx Ecx, S_T.wMonth
      Movzx Edx, S_T.wYear
      Invoke wsprintf, Addr TMP_Buffer, TextAddr("%u/%u/%u%s  -> In USER Mode"), Ebx, Ecx, Edx, Addr TAB
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
      Movzx Ebx, S_T.wHour
      Movzx Ecx, S_T.wMinute
      Movzx Edx, S_T.wSecond
      Invoke wsprintf, Addr TMP_Buffer, TextAddr("%u:%u:%u%s  -> In USER Mode"), Ebx, Ecx, Edx, Addr TAB
      Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
	Ret
Read_File EndP
Write_File Proc Private
                        Local BRet:SDWord
      Invoke SendMessage, hList, LB_RESETCONTENT, NULL, NULL
      ;---
      Mov BRet, 0
      Call SetTimeDate
      .If Eax == 0  ; Set time date OK
         Invoke WriteFile, hFile, Addr TF, SizeOf TF, Addr BRet, NULL
         .If BRet != SizeOf TF
      	    Invoke SendMessage, hList, LB_ADDSTRING, NULL, TextAddr("Write File Err.")
         .EndIf
      .EndIf
	Ret
Write_File EndP

ECTimeDrvTestD_ Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestD_ EndP

ECTimeDrvTestMO_ Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestMO_ EndP

ECTimeDrvTestY_ Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestY_ EndP

ECTimeDrvTestH_ Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestH_ EndP

ECTimeDrvTestMI_ Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestMI_ EndP

ECTimeDrvTestS_ Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestS_ EndP

ECTimeDrvTestList1 Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestList1 EndP
Simple_Init Proc Private

    Invoke GetWindowItem, App.Main, IDC_ECTIMEDRVTEST_LIST1
    Mov hList, Eax
    Invoke GetWindowItem, App.Main, IDC_ECTIMEDRVTEST_Y_
    Mov Y_hwnd, Eax
    Invoke GetWindowItem, App.Main, IDC_ECTIMEDRVTEST_MO_
    Mov MO_hwnd, Eax
    Invoke GetWindowItem, App.Main, IDC_ECTIMEDRVTEST_D_
    Mov D_hwnd, Eax
    Invoke GetWindowItem, App.Main, IDC_ECTIMEDRVTEST_H_
    Mov H_hwnd, Eax
    Invoke GetWindowItem, App.Main, IDC_ECTIMEDRVTEST_MI_
    Mov MI_hwnd, Eax
    Invoke GetWindowItem, App.Main, IDC_ECTIMEDRVTEST_S_
    Mov S_hwnd, Eax
    ;--
    Mov Eax, Offset TABs
    Mov DWord Ptr [Eax], 60
    Mov DWord Ptr [Eax + 4], 120
    Invoke SendMessage, hList, LB_SETTABSTOPS, 2, Addr TABs
    ;--
	Ret
Simple_Init EndP

ShowTimeDate Proc Private

      	  Movzx Eax, TF.Year
          Invoke String, Eax, Addr TMP_Buffer, ecDecimal
          Invoke SetText, Y_hwnd, Addr TMP_Buffer
      	  Movzx Eax, TF.Month
          Invoke String, Eax, Addr TMP_Buffer, ecDecimal
          Invoke SetText, MO_hwnd, Addr TMP_Buffer
      	  Movzx Eax, TF.Day
          Invoke String, Eax, Addr TMP_Buffer, ecDecimal
          Invoke SetText, D_hwnd, Addr TMP_Buffer

      	  Movzx Eax, TF.Hour
          Invoke String, Eax, Addr TMP_Buffer, ecDecimal
          Invoke SetText, H_hwnd, Addr TMP_Buffer
      	  Movzx Eax, TF.Minute
          Invoke String, Eax, Addr TMP_Buffer, ecDecimal
          Invoke SetText, MI_hwnd, Addr TMP_Buffer
      	  Movzx Eax, TF.Second
          Invoke String, Eax, Addr TMP_Buffer, ecDecimal
          Invoke SetText, S_hwnd, Addr TMP_Buffer

	Ret
ShowTimeDate EndP

SetTimeDate Proc Private
                   Local ErrPtr:DWord
    Invoke GetText, Y_hwnd, Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    .If SWord Ptr Ax > 1601
    	Mov TF.Year, Ax
    .Else
    	Mov ErrPtr, TextAddr("Year")
    	Jmp STD_Sal
    .EndIf
    Invoke GetText, MO_hwnd, Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    .If (SWord Ptr Ax > 0) && (SWord Ptr Ax < 13)
    	Mov TF.Month, Ax
    .Else
    	Mov ErrPtr, TextAddr("Month")
    	Jmp STD_Sal
    .EndIf
    Invoke GetText, D_hwnd, Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    .If (SWord Ptr Ax > 0) && (SWord Ptr Ax < 32)
    	Mov TF.Day, Ax
    .Else
    	Mov ErrPtr, TextAddr("Day")
    	Jmp STD_Sal
    .EndIf
    ;--
    Invoke GetText, H_hwnd, Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    .If (SWord Ptr Ax >= 0) && (SWord Ptr Ax < 24)
    	Mov TF.Hour, Ax
    .Else
    	Mov ErrPtr, TextAddr("Hour")
    	Jmp STD_Sal
    .EndIf
    Invoke GetText, MI_hwnd, Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    .If (SWord Ptr Ax >= 0) && (SWord Ptr Ax < 60)
    	Mov TF.Minute, Ax
    .Else
    	Mov ErrPtr, TextAddr("Minute")
    	Jmp STD_Sal
    .EndIf
    Invoke GetText, S_hwnd, Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    .If (SWord Ptr Ax >= 0) && (SWord Ptr Ax < 60)
    	Mov TF.Second, Ax
    .Else
    	Mov ErrPtr, TextAddr("Second")
    	Jmp STD_Sal
    .EndIf
    Mov Eax, 0        ; OK
	Ret
    ;---
STD_Sal:
		Invoke lstrcpy, Addr TMP_Buffer, ErrPtr
		Invoke lstrcat, Addr TMP_Buffer, TextAddr(" Invalid")
		Invoke SendMessage, hList, LB_ADDSTRING, NULL, Addr TMP_Buffer
        Mov Eax, -1  ; Error
        Ret
        ;----
SetTimeDate EndP

ECTimeDrvTestButton2 Proc hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Return FALSE
ECTimeDrvTestButton2 EndP
